<?php
namespace Concrete\Package\CkeditorKaomoji;

use Package;
use Permissions;
use AssetList;
use Asset;
use View;
use Events;
use Kaomoji\Kaomoji;

class Controller extends Package
{
    protected $pkgHandle = 'ckeditor_kaomoji';
    protected $appVersionRequired = '8.0';
    protected $pkgVersion = '1.0';
    protected $pkg;
    protected $permissions;
    protected $settings;

    protected $pkgAutoloaderRegistries = [
        'src/Kaomoji' => '\Kaomoji',
    ];

    public function getPackageDescription()
    {
        return t("Insert hundreds of Japanese Emojis in your content %s Developed by Nour Akalay @ %sKALMOYA - bespoke Concrete5 development%s", '<br /><span style="font-size:11px;">', '<a target="_blank" href="https://kalmoya.com">', '</a></span>');
    }

    public function getPackageName()
    {
        return t("Kaomoji for CKEditor");
    }

    public function on_start()
    {
        $this->permissions = new Permissions();
        if ($this->permissions->canEditPageContents()) {
            Kaomoji::ActivatePlugins();
        }

        $al = AssetList::getInstance();
        $al->register(
            'css',
            'kaomoji/kaomoji-styling',
            'css/kaomoji-styles.css',
            ['version' => '1.0',
                'position' => Asset::ASSET_POSITION_HEADER,
                'minify' => true,
                'combine' => true, ],
            $this
        );

        Events::addListener('on_page_view', function () {
            $v = View::getInstance();
            if (is_object($v)) {
                $v->requireAsset('css', 'kaomoji/kaomoji-styling');
            }
        });
    }

    public function install()
    {
        $this->pkg = parent::install();
    }

    public function upgrade()
    {
        parent::upgrade();
    }
}
